﻿using System;
using System.Collections.Generic;
using System.IO;

namespace Application
{
    public class FileSystem
    {
        public static bool CreateFile(String filename)
        {
            FileStream fs = null;
            try
            {
                //incorrect file name
                if(filename.IndexOfAny(Path.GetInvalidFileNameChars()) >= 0)
                    throw new Exception("Incorrect filename!");
                else
                {
                    fs = File.Create(filename);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            finally
            {
                if(!(fs==null))
                    fs.Close();
            }

            if (fs != null)
                return true;
            else
                return false;
        }

        public static void SaveUsersToFile(String filename, List<User> users)
        {
            try
            {
                using (StreamWriter writer = new StreamWriter(Path.Combine(Directory.GetCurrentDirectory(), filename)))
                {
                    foreach (var user in users)
                    {
                        writer.WriteLine(user.FirstName);
                        writer.WriteLine(user.LastName);
                        writer.WriteLine(user.City);
                        writer.WriteLine(user.Pesel);
                    }
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
        }
    }
}
